#Использовать v8runner

Перем мРабочийКаталогСборки;

// Возвращает значение рабочего каталога, глобальное для всех шагов сборки
//
Функция РабочийКаталог() Экспорт
    
    Если мРабочийКаталогСборки = Неопределено Тогда
        СИ = Новый СистемнаяИнформация;
        
        Переменная = СИ.ПолучитьПеременнуюСреды(ИмяПеременнойОкруженияКаталогСборки());
        Если Не ПустаяСтрока(Переменная) Тогда
            мРабочийКаталогСборки = Переменная;
        Иначе
            мРабочийКаталогСборки = ОбъединитьПути(ТекущийКаталог(), ".packman");
        КонецЕсли;
    КонецЕсли;
    
    Возврат мРабочийКаталогСборки;
    
КонецФункции // РабочийКаталог() Экспорт

// Получает конфигуратор, настроенный на рабочий каталог и временную базу
//
Функция ПолучитьКонфигуратор() Экспорт
    
    УК = Новый УправлениеКонфигуратором();
    УК.КаталогСборки(РабочийКаталог());
    
    Возврат УК;
    
КонецФункции

Функция ИмяПеременнойОкруженияКаталогСборки() Экспорт
    Возврат "VPACKMAN_WORKDIR";
КонецФункции

Функция ИмяКаталогаФормированияДистрибутива() Экспорт
    Возврат "distr";
КонецФункции

Функция ИмяФайлаИнформацииОМетаданных() Экспорт
    Возврат "v8-metadata.info";
КонецФункции // ИмяФайлаИнформацииОМетаданных()

Функция ПрочитатьИнформациюОМетаданных(Знач ИмяФайла) Экспорт
    
    Результат = Новый Структура();
    ЧтениеТекста = Новый ЧтениеТекста(ИмяФайла);
    Пока Истина Цикл
        Стр = ЧтениеТекста.ПрочитатьСтроку();
        Если Стр = Неопределено Тогда
            Прервать;
        КонецЕсли;
        
        Позиция = Найти(Стр, "=");
        Если Позиция = 0 Тогда
            Продолжить;
        КонецЕсли;
        
        Результат.Вставить(Лев(Стр, Позиция-1), Сред(Стр, Позиция+1));
        
    КонецЦикла;
    
    Если Не Результат.Свойство("Версия") Тогда
        ЧтениеТекста.Закрыть();
        ВызватьИсключение "Не найдено поле Версия в файле метаданных";
    КонецЕсли;
    
    ЧтениеТекста.Закрыть();
    
    Возврат Результат;
    
КонецФункции // ПрочитатьИнформациюОМетаданных()